package at.htl.mockingdemo.business;

import at.htl.mockingdemo.entities.Customer;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.MatcherAssert.assertThat;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;

public class CustomerFacadeTest {

    // Aus dem Interface wird eine Mockobjekt erstellt
    @Mock
    MailService mailService;

    // das Mockobjekt mailService wird in die customerFacade injiziert
    @InjectMocks
    CustomerFacade customerFacade;

    @Before
    public void setup() {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void testMailService() {

        // arrange
        Customer minnie = new Customer(200L, "Minnie Mouse", "minnie.mouse@entenhausen.com");

        // when

        // then
        customerFacade.sendMail(minnie, "Neue Aktionen verfügbar");
        verify(mailService, times(1)).send(minnie, "Neue Aktionen verfügbar");

    }



}